%kmdl video4linux

%define snapshot 20040513_184431
%define pkg_snapshot 20040513-184431
%define ver_bt 0.9.15
%define ver_sa 0.2.12
%define ver_cx 0.0.4

Summary: V4L2 drivers from bytesex.org.
Name: video4linux
Version: %{snapshot}
Epoch: 1
Release: 44.1.2%{?dist}
URL: http://linux.bytesex.org/
Source0: http://dl.bytesex.org/cvs-snapshots/video4linux-%{pkg_snapshot}.tar.gz
Source1: patchtvcard
Source2: fixtvcard.TXT
Source3: bttv.init
License: GPL
Group: Applications/Multimedia
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: perl
%kmdl_parentdependencies

%description
This package contains various v4l2 drivers from http://linux.bytesex.org/.

%package -n %kmdl_name
%kmdl_dependencies
Summary: Common modules for V4L2 drivers.
Version: %{snapshot}
Epoch: 1
Group: System Environment/Kernel

%description -n %kmdl_name
This package contains various v4l2 drivers from http://linux.bytesex.org/.

%kmdl_desc

%kmdl bttv
%package -n bttv
Summary: A V4L2 driver for Bt8x8 based video capture cards.
Version: %{ver_bt}_%{snapshot}
Epoch: 1
URL: http://bytesex.org/bttv/
License: GPL
Group: Applications/Multimedia
Requires: video4linux = %{epoch}:%{snapshot}-%{release}
%kmdl_parentdependencies

%description -n bttv
Major rewrite of the bttv core code. Requires: kernel with v4l2-api
patch applied. Recent modutils (>= 2.4.14).

Be prepeared that software which depends on undocumented bttv features
breaks.

%package -n %kmdl_name
%kmdl_dependencies
Summary: A V4L2 driver for Bt8x8 based video capture cards.
Version: %{ver_bt}_%{snapshot}
Epoch: 1
Group: System Environment/Kernel
Requires: %{kmdl_nameof video4linux} = %{epoch}:%{snapshot}-%{release}

%description -n %kmdl_name
%kmdl_desc

%kmdl saa7134
%package -n saa7134
Summary: A V4L/OSS device for saa7130/34 based TV/capture cards.
Version: %{ver_sa}_%{snapshot}
Epoch: 1
URL: http://bytesex.org/saa7134/
License: GPL
Group: Applications/Multimedia
Requires: video4linux = %{epoch}:%{snapshot}-%{release}
%kmdl_parentdependencies

%description -n saa7134
Almost everything is working. video, sound, ...
As with bttv, card-specific tweaks are needed.

still todo:

    * vbi needs more work.
    * plenty of finetuning ... 

supported cards

  0 -> UNKNOWN/GENERIC                         
  1 -> Proteus Pro [philips reference design]   [1131:2001]
  2 -> LifeView FlyVIDEO3000                   
  3 -> LifeView FlyVIDEO2000                   
  4 -> EMPRESS                                  [1131:6752]
  5 -> SKNet Monster TV                         [1131:4e85]
  6 -> Tevion MD 9717                          
  7 -> KNC One TV-Station RDS                  
  8 -> Terratec Cinergy 400 TV                  [153B:1142]
  9 -> Medion 5044                             
 10 -> Kworld/KuroutoShikou SAA7130-TVPCI      
 11 -> Terratec Cinergy 600 TV                  [153B:1143]

%package -n %kmdl_name
%kmdl_dependencies
Summary: Kernel drivers for saa7130/34 based TV/capture cards.
Version: %{ver_sa}_%{snapshot}
Epoch: 1
Group: System Environment/Kernel
Requires: %{kmdl_nameof video4linux} = %{epoch}:%{snapshot}-%{release}

%description -n %kmdl_name
%kmdl_desc

%kmdl cx88
%package -n cx88
Summary: A V4L2 driver for the conexant 2388x chip family.
Version: %{ver_cx}_%{snapshot}
Epoch: 1
URL: http://bytesex.org/cx88/
License: GPL
Group: Applications/Multimedia
Requires: video4linux = %{epoch}:%{snapshot}-%{release}
%kmdl_parentdependencies

%description -n cx88
This is a v4l2 device driver for TV cards based on the conexant 2388x
chip family. Most prominent piece of hardware are the recent Hauppauge
WinTV cards.

%package -n %kmdl_name
%kmdl_dependencies
Summary: A V4L2 driver for the conexant 2388x chip family.
Version: %{ver_cx}_%{snapshot}
Epoch: 1
Group: System Environment/Kernel
Requires: %{kmdl_nameof video4linux} = %{epoch}:%{snapshot}-%{release}

%description -n %kmdl_name
%kmdl_desc

%prep
%setup -q -n %{name}
mkdir linux
cp -a videodev*.h video-buf.h linux/
perl -pi -e's/^install/old_install/' Makefile
cat >> Makefile <<"EOF"
DEST		:= %{buildroot}%{kmdl_moduledir}/drivers/video/media
install::
	strip --strip-debug $(obj-m)
	mkdir -p $(DEST)
	cp -v $(obj-m) $(DEST)
EOF

cp -a %{SOURCE2} .

%build
%if %{kmdl_userland}
%else
%kmdl_config

make -C %{kmdl_kernelsrcdir} SUBDIRS=`pwd` modules

%endif

%install
rm -rf %{buildroot}

%if %{kmdl_userland}

mkdir -p %{buildroot}%{_libdir}/bttv
install -p -m755 %{SOURCE1} %{buildroot}%{_libdir}/bttv
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
install -p -m755 %{SOURCE3} %{buildroot}%{_sysconfdir}/rc.d/init.d/bttv

%else

%makeinstall

%endif

%clean
rm -rf %{buildroot}

%post -n bttv
/sbin/chkconfig --add bttv

%preun -n bttv
if [ $1 = 0 ]; then
  /sbin/chkconfig --del bttv
fi

%kmdl video4linux
%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%kmdl bttv
%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%kmdl saa7134
%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%kmdl cx88
%post -n %kmdl_name
%kmdl_install

%postun -n %kmdl_name
%kmdl_remove

%if %{kmdl_userland}

%files
%defattr(-,root,root,-)
%doc doc/*

%files -n bttv
%defattr(-,root,root,-)
%doc fixtvcard.TXT
%{_libdir}/bttv/patchtvcard
%{_sysconfdir}/rc.d/init.d/bttv

%files -n saa7134
%defattr(-,root,root,-)

%files -n cx88
%defattr(-,root,root,-)

%else

%kmdl video4linux
%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}/drivers/video/media/v4l2-common.o
%{kmdl_moduledir}/drivers/video/media/v4l1-compat.o
%{kmdl_moduledir}/drivers/video/media/video-buf.o
%{kmdl_moduledir}/drivers/video/media/tuner.o
%{kmdl_moduledir}/drivers/video/media/tda9887.o
%{kmdl_moduledir}/drivers/video/media/tvmixer.o

%kmdl bttv
%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}/drivers/video/media/btcx-risc.o
%{kmdl_moduledir}/drivers/video/media/bttv.o

%{kmdl_moduledir}/drivers/video/media/ir-common.o
%{kmdl_moduledir}/drivers/video/media/msp3400.o

%{kmdl_moduledir}/drivers/video/media/tvaudio.o

%kmdl saa7134
%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}/drivers/video/media/saa6752hs.o
%{kmdl_moduledir}/drivers/video/media/saa7134.o

%{kmdl_moduledir}/drivers/video/media/ir-common.o
%{kmdl_moduledir}/drivers/video/media/msp3400.o

%{kmdl_moduledir}/drivers/video/media/tvaudio.o

%kmdl cx88
%files -n %kmdl_name
%defattr(-,root,root,-)
%{kmdl_moduledir}/drivers/video/media/btcx-risc.o
%{kmdl_moduledir}/drivers/video/media/cx8800.o
%{kmdl_moduledir}/drivers/video/media/cx88xx.o

%endif

%changelog
* Thu May 13 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to snapshot 20040515.

* Wed Feb 18 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to snapshot 20040218.

* Thu Feb 12 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Still fixing the last remnants of the kmdl provides bug
  (reported by Preet Khalsa <preet@ecbit.com>).

* Thu Feb  5 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Fix kmdl provides (reported by Stefan Smietanowski <stesmi@stesmi.com>).

* Wed Jan 21 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Use video4linux as base source.
- Effectivly merged bttv, saa7134 and cx88 into one srpm.
- merged changelogs.
- Fixed order of snapshot/version, epoch bump required :(

* Sun Dec 21 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [cx88] Update to 0.0.1.

* Sun Dec 21 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [saa7134] Update to 0.2.9.
- [saa7134] Remove i2c >= 2.8.0 patch, it is handled upstream now.

* Sat Dec 20 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Update to 0.9.12.
- [bttv] Remove i2c >= 2.8.0 patch, it is handled upstream now.

* Tue Sep 30 2003 Axel Thimm <Axel.Thimm@ATrpms.net> 
- [cx88] Initial build.

* Sun Aug 10 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [saa7134] Update to 0.2.8.

* Sun Aug 10 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Update to 0.9.11.

* Tue Jun 17 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [saa7134] Initial build.
- [saa7134] Used bttv spec as a template.

* Wed Jun 11 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Updated to 0.9.10.
- [bttv] Add Ali's patch for ALi M1647/M1651.

* Wed Mar 19 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Updated to 0.9.7.

* Tue Mar 11 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Used new kernel module build packaging environment.

* Wed Mar  5 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Updated to 0.9.6.

* Sat Nov 16 2002 Axel Thimm <Axel.Thimm@ATrpms.net>
- [bttv] Initial build.
